\chapter{Implementation}
The implementation of the algorithm is done in the Rust programming language \footnote{\href{rust-lang.org/}{rust-lang.org/}} and contained in the git sub module \mintinline{sh}{spam-align} of the alignment evaluation folder.\\
The core part of the algorithm as described in \ref{chap:algorithm} is designed to iteratively maintain a partial alignment, as per definition \ref{def:alignment}, that allows the fast insertion of newly aligned sites as well as to check if a given pair of sites is consistent with the current alignment.\\
While an initial implementation, called GABIOS-LIB, is part of the \textit{Dialign2.2} program, \textit{spam-align} contains an improved reimplementation of that library.\\
Although the algorithm as described in \ref{alg:add-site-pair-revised} has the same asymptotic time and memory complexity as the initial implementation, considerable effort was spent on improving the actual implementation by simplifying the code, increasing the cache friendliness, reducing unnecessary allocations and generally enhancing the performance.
% TODO should this be here or in appendix?
\begin{multicols}{2}
\begin{minted}[tabsize=1]{rust}
pub struct Closure {
	sequences: Sequences,
	alig_set: Matrix<usize>,
	
	nbr_alig_sets: usize,
	old_nbr_alig_sets: usize,
	
	pred_frontier: Matrix<usize>,
	succ_frontier: Matrix<usize>,
	
	pred_frontier_ops: Vec<FrontierOp>,
	succ_frontier_ops: Vec<FrontierOp>,
}
\end{minted}

\begin{minted}[tabsize=2]{rust}
struct Sequences {
	lengths: Vec<usize>,
	alig_set_nbr: Matrix<usize>,
	pred_alig_set_pos: Matrix<usize>,
	succ_alig_set_pos: Matrix<usize>,
}
\end{minted}
\captionof{listing}{Data types responsible for storing transitive closure.}
\label{lst:core-types}
\end{multicols}

Listing \ref{lst:core-types} provides the definition of the core data types responsible for tracking the status of an alignment that is constructed by iteratively aligning sites. A \mintinline{rust}{struct} in Rust functions as a simple record of heterogeneous data similar to those in the \textit{C} programming language. Members of a \mintinline{rust}{struct} are defined as \code{<name of member field>: <type of field>}.\\
In contrast to GABIOS-LIB, a dedicated \code{Matrix} type is used which is backed by a contiguous section of memory and not a pointer to memory containing pointers to the actual data. Allocating a matrix of $n$ rows thus only takes a single allocation instead of $n+1$, additionally reducing pointer indirection and increasing CPU cache utilization.\\
For the algorithm \ref{alg:add-site-pair-revised} the predecessor frontiers of $x$ and $y$ are needed, so that sequences $j$, for which there is no possibility of change, can be skipped. Distinguishing the improved algorithm is the detail that these frontiers do not need to be computed for each insertion of a site pair and stored in a separate data structure; rather it is sufficient, and faster, to simply compute the appropriate alignment set index and provide $pred_x$ as a pointer to the right row of $pred$.\\
A key difference and major improvement is constituted by the way updates to the frontiers are applied. Since line \ref{alg:add-site-pair-revised_data-dep} introduces a data anti-dependency,meaning a value must be written after it is read, between successive iterations, changing the transitivity frontiers can not be done in place. In the improved version \code{FrontierOperations} consisting of the alignment set index, the sequence and the new frontier value are stored in a growable memory buffer, called a \code{Vec}, and applied to the frontiers afterwards. Although applying the changes in this way might require more memory than storing the new values in a $N\times N$ matrix and computing the requisite indices for the $pred$ structure, it does not lead to asymptotically more memory consumption and has the benefit of being considerably faster.\\
The member \code{sequences} of the \code{Closure} struct is implemented as a vector of structs containing vectors, again introducing overhead by pointer indirection. 

\mintinline{rust}{alig_set: Matrix<usize>} is a 2-dimensional matrix implementation containing \mintinline{rust}{usize} elements, which are usigned integers with a size equal to the target architecture pointer size (meaning 64 bits on a 64 bit target). 


Differences to Gabios-Lib
\begin{itemize}
	\item matrices are contiguous memory instead of pointer of pointers -> reduces indirection and improves cache locality
	\item no unnecessary left and right buffers which need to be written each iteration
	\item frontier ops instead of pos matrix allows applying frontier changes in $O(\#changes)$ instead of $O(\#seq^2 * \text{part in while loop, don't know upper bound})$
	\item sequences is struct of matrices instead of Vec of struct of vecs -> less indirection
\end{itemize}

